# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/clock/riscv,rpmi-clock.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: RISC-V RPMI clock service group based clock controller

maintainers:
  - Anup Patel <anup@brainfault.org>

description: |
  The RISC-V Platform Management Interface (RPMI) [1] defines a
  messaging protocol which is modular and extensible. The supervisor
  software can send/receive RPMI messages via SBI MPXY extension [2]
  or some dedicated supervisor-mode RPMI transport.

  The RPMI specification [1] defines clock service group for accessing
  system clocks managed by a platform microcontroller. The supervisor
  software can access RPMI clock service group via SBI MPXY channel or
  some dedicated supervisor-mode RPMI transport.

  ===========================================
  References
  ===========================================

  [1] RISC-V Platform Management Interface (RPMI) v1.0 (or higher)
      https://github.com/riscv-non-isa/riscv-rpmi/releases

  [2] RISC-V Supervisor Binary Interface (SBI) v3.0 (or higher)
      https://github.com/riscv-non-isa/riscv-sbi-doc/releases

properties:
  compatible:
    description:
      Intended for use by the supervisor software.
    const: riscv,rpmi-clock

  mboxes:
    maxItems: 1
    description:
      Mailbox channel of the underlying RPMI transport or SBI message proxy channel.

  "#clock-cells":
    const: 1
    description:
      Platform specific CLOCK_ID as defined by the RISC-V Platform Management
      Interface (RPMI) specification.

required:
  - compatible
  - mboxes
  - "#clock-cells"

additionalProperties: false

examples:
  - |
    clock-controller {
        compatible = "riscv,rpmi-clock";
        mboxes = <&mpxy_mbox 0x1000 0x0>;
        #clock-cells = <1>;
    };
...
